| AI Engine API User Guide (AIE-API) 2025.2

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
aie::restrict_vector_iterator< T, Elems, Resource > Class Template Reference

`#include <iterator.hpp>`

## Public Types
using | difference_type = ptrdiff_t
using | iterator_category = std::random_access_iterator_tag
using | pointer = std::conditional_t<std::is_const_v<T>, const value_type *, value_type *>
using | reference = std::conditional_t<std::is_const_v<T>, const value_type &, value_type &>
using | value_type = vector_type

## Public Member Functions
bool | operator!= (const restrict_vector_iterator &other) const
| Return true if the two iterators reference different values.
reference | operator* ()
| Accesses the value in the iterator.
restrict_vector_iterator | operator+ (difference_type off) const
| Returns a copy of the iterator that is located a number of steps ahead.
restrict_vector_iterator & | operator++ ()
| Pre-fix increment: advances the iterator one step.
restrict_vector_iterator | operator++ (int)
| Post-fix increment: advances the iterator one step and returns a copy of its old state.
restrict_vector_iterator | operator+= (difference_type off)
| Moves the iterator a number of steps forward.
restrict_vector_iterator | operator- (difference_type off) const
| Returns a copy of the iterator that is located a number of steps behind.
restrict_vector_iterator & | operator-- ()
| Pre-fix decrement: moves the iterator one step back.
restrict_vector_iterator | operator-- (int)
| Post-fix increment: moves the iterator one step back and returns a copy of its old state.
restrict_vector_iterator | operator-= (difference_type off)
| Moves the iterator a number of steps back.
pointer | operator-> ()
| Accesses the value in the iterator.
bool | operator== (const restrict_vector_iterator &other) const
| Return true if the two iterators reference the same value.
reference | operator[] (difference_type off)
| Accesses the value a number of steps away from the iterator.

## Member Typedef Documentation

## ◆ difference_type

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

using aie::restrict_vector_iterator< T, Elems, Resource >::difference_type = ptrdiff_t

## ◆ iterator_category

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

using aie::restrict_vector_iterator< T, Elems, Resource >::iterator_category = std::random_access_iterator_tag

## ◆ pointer

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

using aie::restrict_vector_iterator< T, Elems, Resource >::pointer = std::conditional_t<std::is_const_v<T>, const value_type *, value_type *>

## ◆ reference

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

using aie::restrict_vector_iterator< T, Elems, Resource >::reference = std::conditional_t<std::is_const_v<T>, const value_type &, value_type &>

## ◆ value_type

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

using aie::restrict_vector_iterator< T, Elems, Resource >::value_type = vector_type

## Member Function Documentation

## ◆ operator!=()

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

bool aie::restrict_vector_iterator< T, Elems, Resource >::operator!= | ( | const restrict_vector_iterator< T, Elems, Resource > & | other | ) | const
| inline

Return true if the two iterators reference different values.

## ◆ operator*()

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

reference aie::restrict_vector_iterator< T, Elems, Resource >::operator* | ( |  | ) |
| inline

Accesses the value in the iterator.

## ◆ operator+()

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

restrict_vector_iterator aie::restrict_vector_iterator< T, Elems, Resource >::operator+ | ( | difference_type | off | ) | const
| inline

Returns a copy of the iterator that is located a number of steps ahead.

## ◆ operator++() [1/2]

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

restrict_vector_iterator & aie::restrict_vector_iterator< T, Elems, Resource >::operator++ | ( |  | ) |
| inline

Pre-fix increment: advances the iterator one step.

Returns
  a reference to the iterator

See also
  operator++(int)

## ◆ operator++() [2/2]

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

restrict_vector_iterator aie::restrict_vector_iterator< T, Elems, Resource >::operator++ | ( | int |  | ) |
| inline

Post-fix increment: advances the iterator one step and returns a copy of its old state.

Returns
  a copy of the iterator before the increment operation took place.

See also
  operator++()

## ◆ operator+=()

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

restrict_vector_iterator aie::restrict_vector_iterator< T, Elems, Resource >::operator+= | ( | difference_type | off | ) |
| inline

Moves the iterator a number of steps forward.

## ◆ operator-()

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

restrict_vector_iterator aie::restrict_vector_iterator< T, Elems, Resource >::operator- | ( | difference_type | off | ) | const
| inline

Returns a copy of the iterator that is located a number of steps behind.

## ◆ operator--() [1/2]

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

restrict_vector_iterator & aie::restrict_vector_iterator< T, Elems, Resource >::operator-- | ( |  | ) |
| inline

Pre-fix decrement: moves the iterator one step back.

Returns
  a reference to the iterator

See also
  operator--(int)

## ◆ operator--() [2/2]

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

restrict_vector_iterator aie::restrict_vector_iterator< T, Elems, Resource >::operator-- | ( | int |  | ) |
| inline

Post-fix increment: moves the iterator one step back and returns a copy of its old state.

Returns
  a copy of the iterator before the increment operation took place.

See also
  operator--()

## ◆ operator-=()

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

restrict_vector_iterator aie::restrict_vector_iterator< T, Elems, Resource >::operator-= | ( | difference_type | off | ) |
| inline

Moves the iterator a number of steps back.

## ◆ operator->()

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

pointer aie::restrict_vector_iterator< T, Elems, Resource >::operator-> | ( |  | ) |
| inline

Accesses the value in the iterator.

## ◆ operator==()

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

bool aie::restrict_vector_iterator< T, Elems, Resource >::operator== | ( | const restrict_vector_iterator< T, Elems, Resource > & | other | ) | const
| inline

Return true if the two iterators reference the same value.

## ◆ operator[]()

template<typename T, unsigned Elems, aie_dm_resource Resource = aie_dm_resource::none>

reference aie::restrict_vector_iterator< T, Elems, Resource >::operator[] | ( | difference_type | off | ) |
| inline

Accesses the value a number of steps away from the iterator.

The documentation for this class was generated from the following file:

- iterator.hpp